/* Utils.c generated by valac 0.40.6, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * Copyright (c) 2011-2015 elementary LLC. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define POWER_SERVICES_TYPE_DEVICE (power_services_device_get_type ())
#define POWER_SERVICES_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_SERVICES_TYPE_DEVICE, PowerServicesDevice))
#define POWER_SERVICES_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POWER_SERVICES_TYPE_DEVICE, PowerServicesDeviceClass))
#define POWER_SERVICES_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_SERVICES_TYPE_DEVICE))
#define POWER_SERVICES_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POWER_SERVICES_TYPE_DEVICE))
#define POWER_SERVICES_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POWER_SERVICES_TYPE_DEVICE, PowerServicesDeviceClass))

typedef struct _PowerServicesDevice PowerServicesDevice;
typedef struct _PowerServicesDeviceClass PowerServicesDeviceClass;
#define _g_free0(var) (var = (g_free (var), NULL))



gboolean power_utils_type_is_battery (guint32 device_type);
#define DEVICE_TYPE_UNKNOWN ((guint32) 0)
#define DEVICE_TYPE_LINE_POWER ((guint32) 1)
gboolean power_utils_type_has_device_icon (guint32 device_type);
#define DEVICE_TYPE_PHONE ((guint32) 8)
#define DEVICE_TYPE_MOUSE ((guint32) 5)
#define DEVICE_TYPE_KEYBOARD ((guint32) 6)
GType power_services_device_get_type (void) G_GNUC_CONST;
gchar* power_utils_get_symbolic_icon_name_for_battery (PowerServicesDevice* battery);
gchar* power_utils_get_icon_name_for_battery (PowerServicesDevice* battery);
gchar* power_utils_get_symbolic_icon_name_for_backlight (void);
gdouble power_services_device_get_percentage (PowerServicesDevice* self);
gboolean power_utils_is_charging (guint32 state);
guint32 power_services_device_get_state (PowerServicesDevice* self);
gchar* power_utils_get_battery_icon (gdouble percentage,
                                     gint64 remaining_time);
gint64 power_services_device_get_time_to_empty (PowerServicesDevice* self);
gchar* power_utils_get_icon_name_for_device (PowerServicesDevice* device);
guint32 power_services_device_get_device_type (PowerServicesDevice* self);
#define DEVICE_STATE_FULLY_CHARGED ((guint32) 4)
#define DEVICE_STATE_CHARGING ((guint32) 1)
gchar* power_utils_get_title_for_battery (PowerServicesDevice* battery);
#define DEVICE_TYPE_BATTERY ((guint32) 2)
#define DEVICE_TYPE_UPS ((guint32) 3)
#define DEVICE_TYPE_MONITOR ((guint32) 4)
#define DEVICE_TYPE_PDA ((guint32) 7)
const gchar* power_services_device_get_vendor (PowerServicesDevice* self);
const gchar* power_services_device_get_model (PowerServicesDevice* self);
gchar* power_utils_get_info_for_battery (PowerServicesDevice* battery);
gint64 power_services_device_get_time_to_full (PowerServicesDevice* self);
#define CONSTANTS_GETTEXT_PACKAGE "power-indicator"
void power_utils_translations (void);


gboolean
power_utils_type_is_battery (guint32 device_type)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (device_type != DEVICE_TYPE_UNKNOWN) {
#line 22 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = device_type != DEVICE_TYPE_LINE_POWER;
#line 90 "Utils.c"
	} else {
#line 22 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = FALSE;
#line 94 "Utils.c"
	}
#line 22 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp0_;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 100 "Utils.c"
}


gboolean
power_utils_type_has_device_icon (guint32 device_type)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (device_type == DEVICE_TYPE_PHONE) {
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp1_ = TRUE;
#line 114 "Utils.c"
	} else {
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp1_ = device_type == DEVICE_TYPE_MOUSE;
#line 118 "Utils.c"
	}
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp1_) {
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = TRUE;
#line 124 "Utils.c"
	} else {
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = device_type == DEVICE_TYPE_KEYBOARD;
#line 128 "Utils.c"
	}
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp0_;
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 134 "Utils.c"
}


gchar*
power_utils_get_symbolic_icon_name_for_battery (PowerServicesDevice* battery)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 29 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp0_ = power_utils_get_icon_name_for_battery (battery);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp2_ = g_strconcat (_tmp1_, "-symbolic", NULL);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp3_ = _tmp2_;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_g_free0 (_tmp1_);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp3_;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 162 "Utils.c"
}


gchar*
power_utils_get_symbolic_icon_name_for_backlight (void)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 34 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp0_ = g_strdup ("display-brightness-symbolic");
#line 34 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 177 "Utils.c"
}


gchar*
power_utils_get_icon_name_for_battery (PowerServicesDevice* battery)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 37 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp1_ = power_services_device_get_percentage (battery);
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp2_ = _tmp1_;
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp2_ == ((gdouble) 100)) {
#line 196 "Utils.c"
		guint32 _tmp3_;
		guint32 _tmp4_;
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp3_ = power_services_device_get_state (battery);
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp4_ = _tmp3_;
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = power_utils_is_charging (_tmp4_) == TRUE;
#line 205 "Utils.c"
	} else {
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = FALSE;
#line 209 "Utils.c"
	}
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp0_) {
#line 213 "Utils.c"
		gchar* _tmp5_;
#line 39 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp5_ = g_strdup ("battery-full-charged");
#line 39 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp5_;
#line 39 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 221 "Utils.c"
	} else {
		const gchar* _tmp6_ = NULL;
		guint32 _tmp7_;
		guint32 _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		gint64 _tmp11_;
		gint64 _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 42 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp7_ = power_services_device_get_state (battery);
#line 42 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp8_ = _tmp7_;
#line 42 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		if (power_utils_is_charging (_tmp8_)) {
#line 42 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp6_ = "-charging";
#line 242 "Utils.c"
		} else {
#line 42 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp6_ = "";
#line 246 "Utils.c"
		}
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp9_ = power_services_device_get_percentage (battery);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp10_ = _tmp9_;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp11_ = power_services_device_get_time_to_empty (battery);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp12_ = _tmp11_;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp13_ = power_utils_get_battery_icon (_tmp10_, _tmp12_);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp14_ = _tmp13_;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp15_ = g_strconcat (_tmp14_, _tmp6_, NULL);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp16_ = _tmp15_;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_g_free0 (_tmp14_);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp16_;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 270 "Utils.c"
	}
}


gchar*
power_utils_get_icon_name_for_device (PowerServicesDevice* device)
{
	gchar* result = NULL;
	guint32 _tmp0_;
	guint32 _tmp1_;
#line 46 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp0_ = power_services_device_get_device_type (device);
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	switch (_tmp1_) {
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_PHONE:
#line 291 "Utils.c"
		{
			gchar* _tmp2_;
#line 48 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp2_ = g_strdup ("phone");
#line 48 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			result = _tmp2_;
#line 48 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			return result;
#line 300 "Utils.c"
		}
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_MOUSE:
#line 304 "Utils.c"
		{
			gchar* _tmp3_;
#line 49 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp3_ = g_strdup ("input-mouse");
#line 49 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			result = _tmp3_;
#line 49 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			return result;
#line 313 "Utils.c"
		}
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_KEYBOARD:
#line 317 "Utils.c"
		{
			gchar* _tmp4_;
#line 50 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp4_ = g_strdup ("input-keyboard");
#line 50 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			result = _tmp4_;
#line 50 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			return result;
#line 326 "Utils.c"
		}
		default:
		{
			gchar* _tmp5_;
#line 51 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp5_ = power_utils_get_icon_name_for_battery (device);
#line 51 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			result = _tmp5_;
#line 51 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			return result;
#line 337 "Utils.c"
		}
	}
}


gchar*
power_utils_get_battery_icon (gdouble percentage,
                              gint64 remaining_time)
{
	gchar* result = NULL;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp7_;
#line 56 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (percentage <= ((gdouble) 0)) {
#line 352 "Utils.c"
		gchar* _tmp0_;
#line 57 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = g_strdup ("battery-good");
#line 57 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp0_;
#line 57 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 360 "Utils.c"
	}
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (percentage < ((gdouble) 10)) {
#line 364 "Utils.c"
		gboolean _tmp2_ = FALSE;
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		if (remaining_time == ((gint64) 0)) {
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp2_ = TRUE;
#line 370 "Utils.c"
		} else {
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp2_ = remaining_time < ((gint64) (30 * 60));
#line 374 "Utils.c"
		}
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp1_ = _tmp2_;
#line 378 "Utils.c"
	} else {
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp1_ = FALSE;
#line 382 "Utils.c"
	}
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp1_) {
#line 386 "Utils.c"
		gchar* _tmp3_;
#line 61 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp3_ = g_strdup ("battery-empty");
#line 61 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp3_;
#line 61 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 394 "Utils.c"
	}
#line 64 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (percentage < ((gdouble) 30)) {
#line 398 "Utils.c"
		gchar* _tmp4_;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp4_ = g_strdup ("battery-caution");
#line 65 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp4_;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 406 "Utils.c"
	}
#line 68 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (percentage < ((gdouble) 60)) {
#line 410 "Utils.c"
		gchar* _tmp5_;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp5_ = g_strdup ("battery-low");
#line 69 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp5_;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 418 "Utils.c"
	}
#line 72 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (percentage < ((gdouble) 80)) {
#line 422 "Utils.c"
		gchar* _tmp6_;
#line 73 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp6_ = g_strdup ("battery-good");
#line 73 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp6_;
#line 73 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 430 "Utils.c"
	}
#line 76 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp7_ = g_strdup ("battery-full");
#line 76 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp7_;
#line 76 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 438 "Utils.c"
}


gboolean
power_utils_is_charging (guint32 state)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (state == DEVICE_STATE_FULLY_CHARGED) {
#line 80 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = TRUE;
#line 451 "Utils.c"
	} else {
#line 80 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = state == DEVICE_STATE_CHARGING;
#line 455 "Utils.c"
	}
#line 80 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp0_;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 461 "Utils.c"
}


gchar*
power_utils_get_title_for_battery (PowerServicesDevice* battery)
{
	gchar* result = NULL;
	gchar* title = NULL;
	gchar* _tmp0_;
	guint32 _tmp1_;
	guint32 _tmp2_;
	gboolean _tmp15_ = FALSE;
	guint32 _tmp16_;
	guint32 _tmp17_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
#line 83 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 84 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp0_ = g_strdup ("");
#line 84 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	title = _tmp0_;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp1_ = power_services_device_get_device_type (battery);
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp2_ = _tmp1_;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	switch (_tmp2_) {
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_BATTERY:
#line 492 "Utils.c"
		{
			gchar* _tmp3_;
#line 88 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp3_ = g_strdup (_ ("Battery"));
#line 88 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 88 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp3_;
#line 88 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 503 "Utils.c"
		}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_UPS:
#line 507 "Utils.c"
		{
			gchar* _tmp4_;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp4_ = g_strdup (_ ("UPS"));
#line 89 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 89 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp4_;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 518 "Utils.c"
		}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_MONITOR:
#line 522 "Utils.c"
		{
			gchar* _tmp5_;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp5_ = g_strdup (_ ("Display"));
#line 90 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 90 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp5_;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 533 "Utils.c"
		}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_MOUSE:
#line 537 "Utils.c"
		{
			gchar* _tmp6_;
#line 91 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp6_ = g_strdup (_ ("Mouse"));
#line 91 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 91 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp6_;
#line 91 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 548 "Utils.c"
		}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_KEYBOARD:
#line 552 "Utils.c"
		{
			gchar* _tmp7_;
#line 92 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp7_ = g_strdup (_ ("Keyboard"));
#line 92 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 92 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp7_;
#line 92 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 563 "Utils.c"
		}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_PDA:
#line 567 "Utils.c"
		{
			gchar* _tmp8_;
#line 93 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp8_ = g_strdup (_ ("PDA"));
#line 93 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 93 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp8_;
#line 93 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 578 "Utils.c"
		}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_PHONE:
#line 582 "Utils.c"
		{
			gchar* _tmp9_;
#line 94 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp9_ = g_strdup (_ ("Phone"));
#line 94 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 94 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp9_;
#line 94 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 593 "Utils.c"
		}
		default:
		{
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp10_ = power_services_device_get_vendor (battery);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp11_ = _tmp10_;
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp12_ = g_strconcat (_tmp11_, " ", NULL);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp13_ = _tmp12_;
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp14_ = g_strconcat (_tmp13_, _ ("Device"), NULL);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp14_;
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (_tmp13_);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 620 "Utils.c"
		}
	}
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp16_ = power_services_device_get_device_type (battery);
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp17_ = _tmp16_;
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp17_ == DEVICE_TYPE_PHONE) {
#line 629 "Utils.c"
		const gchar* _tmp18_;
		const gchar* _tmp19_;
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp18_ = power_services_device_get_model (battery);
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp19_ = _tmp18_;
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp15_ = g_strcmp0 (_tmp19_, "") != 0;
#line 638 "Utils.c"
	} else {
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp15_ = FALSE;
#line 642 "Utils.c"
	}
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp15_) {
#line 646 "Utils.c"
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp20_ = power_services_device_get_model (battery);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp21_ = _tmp20_;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp22_ = g_strdup (_tmp21_);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_g_free0 (title);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		title = _tmp22_;
#line 660 "Utils.c"
	}
#line 102 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp23_ = title;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp24_ = g_strdup_printf ("<b>%s</b>", _tmp23_);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp24_;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_g_free0 (title);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 672 "Utils.c"
}


gchar*
power_utils_get_info_for_battery (PowerServicesDevice* battery)
{
	gchar* result = NULL;
	gint percent = 0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gboolean charging = FALSE;
	guint32 _tmp2_;
	guint32 _tmp3_;
	gint _tmp4_;
	gchar* info = NULL;
	gchar* _tmp6_;
	gboolean _tmp7_;
#line 105 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 106 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp0_ = power_services_device_get_percentage (battery);
#line 106 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 106 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	percent = (gint) round (_tmp1_);
#line 107 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp2_ = power_services_device_get_state (battery);
#line 107 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp3_ = _tmp2_;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	charging = power_utils_is_charging (_tmp3_);
#line 109 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp4_ = percent;
#line 109 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp4_ <= 0) {
#line 708 "Utils.c"
		gchar* _tmp5_;
#line 110 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp5_ = g_strdup (_ ("Calculating…"));
#line 110 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp5_;
#line 110 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 716 "Utils.c"
	}
#line 113 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp6_ = g_strdup ("");
#line 113 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	info = _tmp6_;
#line 115 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp7_ = charging;
#line 115 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp7_) {
#line 726 "Utils.c"
		const gchar* _tmp8_;
		gint _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gint64 seconds = 0LL;
		gint64 _tmp13_;
		gint64 _tmp14_;
		gint64 _tmp15_;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp8_ = info;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp9_ = percent;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp10_ = g_strdup_printf (_ ("%i%% charged"), _tmp9_);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp11_ = _tmp10_;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp12_ = g_strconcat (_tmp8_, _tmp11_, NULL);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_g_free0 (info);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		info = _tmp12_;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_g_free0 (_tmp11_);
#line 118 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp13_ = power_services_device_get_time_to_full (battery);
#line 118 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp14_ = _tmp13_;
#line 118 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		seconds = _tmp14_;
#line 120 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp15_ = seconds;
#line 120 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		if (_tmp15_ > ((gint64) 0)) {
#line 762 "Utils.c"
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gint64 _tmp18_;
#line 121 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp16_ = info;
#line 121 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp17_ = g_strconcat (_tmp16_, " - ", NULL);
#line 121 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (info);
#line 121 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			info = _tmp17_;
#line 122 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp18_ = seconds;
#line 122 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			if (_tmp18_ >= ((gint64) 86400)) {
#line 778 "Utils.c"
				gint64 days = 0LL;
				gint64 _tmp19_;
				const gchar* _tmp20_;
				gint64 _tmp21_;
				gint64 _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
#line 123 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp19_ = seconds;
#line 123 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				days = _tmp19_ / 86400;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp20_ = info;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp21_ = days;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp22_ = days;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp23_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld day until full", "%lld days until full", (gulong) _tmp21_), _tmp22_);
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp24_ = _tmp23_;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp25_ = g_strconcat (_tmp20_, _tmp24_, NULL);
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_g_free0 (info);
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				info = _tmp25_;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_g_free0 (_tmp24_);
#line 809 "Utils.c"
			} else {
				gint64 _tmp26_;
#line 125 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp26_ = seconds;
#line 125 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				if (_tmp26_ >= ((gint64) 3600)) {
#line 816 "Utils.c"
					gint64 hours = 0LL;
					gint64 _tmp27_;
					const gchar* _tmp28_;
					gint64 _tmp29_;
					gint64 _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
#line 126 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp27_ = seconds;
#line 126 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					hours = _tmp27_ / 3600;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp28_ = info;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp29_ = hours;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp30_ = hours;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp31_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld hour until full", "%lld hours until full", (gulong) _tmp29_), _tmp30_);
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp32_ = _tmp31_;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp33_ = g_strconcat (_tmp28_, _tmp32_, NULL);
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_g_free0 (info);
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					info = _tmp33_;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_g_free0 (_tmp32_);
#line 847 "Utils.c"
				} else {
					gint64 _tmp34_;
#line 128 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp34_ = seconds;
#line 128 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					if (_tmp34_ >= ((gint64) 60)) {
#line 854 "Utils.c"
						gint64 minutes = 0LL;
						gint64 _tmp35_;
						const gchar* _tmp36_;
						gint64 _tmp37_;
						gint64 _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
#line 129 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp35_ = seconds;
#line 129 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						minutes = _tmp35_ / 60;
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp36_ = info;
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp37_ = minutes;
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp38_ = minutes;
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp39_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld minute until full", "%lld minutes until full", (gulong) _tmp37_), _tmp38_);
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp40_ = _tmp39_;
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp41_ = g_strconcat (_tmp36_, _tmp40_, NULL);
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (info);
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						info = _tmp41_;
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (_tmp40_);
#line 885 "Utils.c"
					} else {
						const gchar* _tmp42_;
						gint64 _tmp43_;
						gint64 _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
						gchar* _tmp47_;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp42_ = info;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp43_ = seconds;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp44_ = seconds;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp45_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld second until full", "%lld seconds until full", (gulong) _tmp43_), _tmp44_);
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp46_ = _tmp45_;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp47_ = g_strconcat (_tmp42_, _tmp46_, NULL);
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (info);
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						info = _tmp47_;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (_tmp46_);
#line 911 "Utils.c"
					}
				}
			}
		}
	} else {
		const gchar* _tmp48_;
		gint _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		gint64 seconds = 0LL;
		gint64 _tmp53_;
		gint64 _tmp54_;
		gint64 _tmp55_;
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp48_ = info;
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp49_ = percent;
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp50_ = g_strdup_printf (_ ("%i%% remaining"), _tmp49_);
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp51_ = _tmp50_;
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp52_ = g_strconcat (_tmp48_, _tmp51_, NULL);
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_g_free0 (info);
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		info = _tmp52_;
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_g_free0 (_tmp51_);
#line 138 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp53_ = power_services_device_get_time_to_empty (battery);
#line 138 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp54_ = _tmp53_;
#line 138 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		seconds = _tmp54_;
#line 140 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp55_ = seconds;
#line 140 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		if (_tmp55_ > ((gint64) 0)) {
#line 952 "Utils.c"
			const gchar* _tmp56_;
			gchar* _tmp57_;
			gint64 _tmp58_;
#line 141 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp56_ = info;
#line 141 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp57_ = g_strconcat (_tmp56_, " - ", NULL);
#line 141 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (info);
#line 141 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			info = _tmp57_;
#line 142 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp58_ = seconds;
#line 142 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			if (_tmp58_ >= ((gint64) 86400)) {
#line 968 "Utils.c"
				gint64 days = 0LL;
				gint64 _tmp59_;
				const gchar* _tmp60_;
				gint64 _tmp61_;
				gint64 _tmp62_;
				gchar* _tmp63_;
				gchar* _tmp64_;
				gchar* _tmp65_;
#line 143 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp59_ = seconds;
#line 143 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				days = _tmp59_ / 86400;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp60_ = info;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp61_ = days;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp62_ = days;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp63_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld day until empty", "%lld days until empty", (gulong) _tmp61_), _tmp62_);
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp64_ = _tmp63_;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp65_ = g_strconcat (_tmp60_, _tmp64_, NULL);
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_g_free0 (info);
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				info = _tmp65_;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_g_free0 (_tmp64_);
#line 999 "Utils.c"
			} else {
				gint64 _tmp66_;
#line 145 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp66_ = seconds;
#line 145 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				if (_tmp66_ >= ((gint64) 3600)) {
#line 1006 "Utils.c"
					gint64 hours = 0LL;
					gint64 _tmp67_;
					const gchar* _tmp68_;
					gint64 _tmp69_;
					gint64 _tmp70_;
					gchar* _tmp71_;
					gchar* _tmp72_;
					gchar* _tmp73_;
#line 146 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp67_ = seconds;
#line 146 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					hours = _tmp67_ / 3600;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp68_ = info;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp69_ = hours;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp70_ = hours;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp71_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld hour until empty", "%lld hours until empty", (gulong) _tmp69_), _tmp70_);
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp72_ = _tmp71_;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp73_ = g_strconcat (_tmp68_, _tmp72_, NULL);
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_g_free0 (info);
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					info = _tmp73_;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_g_free0 (_tmp72_);
#line 1037 "Utils.c"
				} else {
					gint64 _tmp74_;
#line 148 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp74_ = seconds;
#line 148 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					if (_tmp74_ >= ((gint64) 60)) {
#line 1044 "Utils.c"
						gint64 minutes = 0LL;
						gint64 _tmp75_;
						const gchar* _tmp76_;
						gint64 _tmp77_;
						gint64 _tmp78_;
						gchar* _tmp79_;
						gchar* _tmp80_;
						gchar* _tmp81_;
#line 149 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp75_ = seconds;
#line 149 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						minutes = _tmp75_ / 60;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp76_ = info;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp77_ = minutes;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp78_ = minutes;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp79_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld minute until empty", "%lld minutes until empty", (gulong) _tmp77_), _tmp78_);
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp80_ = _tmp79_;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp81_ = g_strconcat (_tmp76_, _tmp80_, NULL);
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (info);
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						info = _tmp81_;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (_tmp80_);
#line 1075 "Utils.c"
					} else {
						const gchar* _tmp82_;
						gint64 _tmp83_;
						gint64 _tmp84_;
						gchar* _tmp85_;
						gchar* _tmp86_;
						gchar* _tmp87_;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp82_ = info;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp83_ = seconds;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp84_ = seconds;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp85_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld second until empty", "%lld seconds until empty", (gulong) _tmp83_), _tmp84_);
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp86_ = _tmp85_;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp87_ = g_strconcat (_tmp82_, _tmp86_, NULL);
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (info);
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						info = _tmp87_;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (_tmp86_);
#line 1101 "Utils.c"
					}
				}
			}
		}
	}
#line 157 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = info;
#line 157 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 1111 "Utils.c"
}


void
power_utils_translations (void)
{
#line 162 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld day until full", "%lld days until full", (gulong) 0);
#line 163 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld hour until full", "%lld hours until full", (gulong) 0);
#line 164 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld minute until full", "%lld minutes until full", (gulong) 0);
#line 165 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld second until full", "%lld seconds until full", (gulong) 0);
#line 166 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld day until empty", "%lld days until empty", (gulong) 0);
#line 167 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld hour until empty", "%lld hours until empty", (gulong) 0);
#line 168 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld minute until empty", "%lld minutes until empty", (gulong) 0);
#line 169 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld second until empty", "%lld seconds until empty", (gulong) 0);
#line 1134 "Utils.c"
}



